// Markus timing (laptop bogomips 5000): real	1m49,793s  with Ofast and 1000000x10 evaluations


#include <math.h>
#include <stdio.h>
#include <complex.h>
#include "vegas.h"

#define DIMENSION 6
#define FUNCTIONS 1

#define PI 3.14159265358979323846

 
void TestIntegrand(double x[DIMENSION], double *wgt, double f[FUNCTIONS])
{  double complex prop1,aux1;
   double spike1,step1;
   const double Msq=(91.19*91.19);
   const double Gamma = 2.0; 
   const double eps=0.3;


  prop1  = 1.0/(x[0]*x[0] - x[1]*x[1] - Msq + I*Gamma*sqrt(Msq));
  spike1 = pow(fabs(x[0]-x[2]),eps-1.0);
  aux1   = x[4]*x[4]*pow(cos(2.0*PI*x[4]),2) + tanh(x[4]);
  if( x[5] >0.5 ) { step1=x[5]; } else { step1 = 0.0; };

  int i=1;
  double complex dummy;
  while( i<= x[5]*1000 )  {
     i++;
     i += i*10*pow(sin(x[4]),2);
     
     dummy = 1.0 - 1.2*I;
     if( x[2]<0.3 ) dummy = (1.0+3.3*I) * cos(x[0]);
     dummy = cpow(dummy,2.5);
     if( x[5]+x[1] <0.7 ) dummy += (1.0+3.3*I) * exp(x[0]*x[0]);
     dummy = cpow(dummy,2.5);
     dummy += (4.0+3.3*I) * exp(x[0]*x[0]);
     if( x[2]*x[1] >0.1 ) dummy = cpow(cabs(dummy),0.6);
     dummy += (9.0+6.3*I) * sinh(x[0]*x[0]);
     if( fmod(i,4)==0 ) dummy += (6.0+1.3*I) * tanh(x[0]*x[0]);
     int j=0;
     while( j < 100  ){ 
           j++;
           if( sin(cabs(dummy)*2.0*PI) > 0.0 ) {dummy += (2.0+2.3*I) * log(x[0]*x[0]+0.1) * cos(2.0*PI*j); }
     };
  };
  

  f[0] = creal(dummy) * i * cabs(prop1)*cabs(prop1) * spike1 * aux1 * step1 * 1000.0;


  return;
}




// main program
int main(int argc, char **argv)
{ /* declare variables */
  int i;
  double estim[FUNCTIONS];   /* estimators for integrals                     */
  double std_dev[FUNCTIONS]; /* standard deviations                          */
  double chi2a[FUNCTIONS];   /* chi^2/n                                      */
  double reg[2*DIMENSION];   /* integration domain                           */



  //  initializing the integration range, always from 0.0 to 1.0
  for (i=0; i<DIMENSION; i++) {
    reg[i] = 0.0;
    reg[i+DIMENSION] = 1.0;
  }

  // setting parameters for vegas integrator
  int init=0;
  unsigned long ncall=1000000;
  int itmx=10;
  
  // calling vegas integrator
  vegas(reg, DIMENSION, TestIntegrand, init, ncall, itmx, NPRN_INPUT | NPRN_RESULT, 1, 0, 1, estim, std_dev, chi2a);
  

  return(0);
}


