!!  Markus timing (laptop bogomips 5000): real 1m53,139s  with Ofast and 1000000x10 evaluations
PROGRAM Benchmark
implicit none
real(8) :: MCresult,MCerror,chi2
integer :: MPI_Rank
!DEC$ IF(_UseMPIVegas.EQ.1)
! include 'mpif.h'
! integer ::ierror
!    call MPI_INIT(ierror)
!    call MPI_COMM_RANK(MPI_COMM_WORLD,MPI_Rank,ierror)
!DEC$ ELSE
   MPI_Rank=0
!DEC$ ENDIF


   call StartPVegas()

!DEC$ IF(_UseMPIVegas .EQ.1)  
!    call MPI_FINALIZE(ierror)
!DEC$ ENDIF


END PROGRAM







SUBROUTINE StartPVegas()
use ModIntegrand
implicit none
real(8) :: MCresult,MCerror,MC_Chi2
!DEC$ IF(_UseMPIVegas .EQ.1)  
! include 'mpif.h'
!DEC$ ENDIF
integer,parameter :: mxdim=10
integer itmx,ncall,nprn,numfunctions,pdim,workers
integer i,init,NDim,NEVAL,IFAIL,kDim,nBuf,nSampl,OptDrive,OptEdge,loop,nregions
double precision yrange(1:2*MXDIM)
INTEGER, PARAMETER :: NW=10000000
REAL(8) :: WORK(1:NW),MCwt,MCvector(10)
integer ::  userdata, nvec, flags, mineval, maxeval, key,  spin, nbatch, gridno,nnew, nmin
double precision :: epsrel, epsabs, flatness



  ndim=6
  ncall = 1000000
  itmx  = 10
  nprn = 3
  numfunctions=1
  pdim=1
  workers=1

  do i=1,ndim
    yrange(i)=0d0
    yrange(i+ndim)=1d0
  enddo

  init=0


!DEC$ IF(_UseMPIVegas .EQ.1)  
!   call vegas_mpi(yrange(1:2*ndim),ndim,VegasIntegrand1,init,ncall,itmx,nprn,NUMFUNCTIONS,PDIM,WORKERS,MCresult,MCerror,MC_Chi2)
!DEC$ ELSE  
  call vegas_ser(yrange(1:2*ndim),ndim,VegasIntegrand1,init,ncall,itmx,nprn,NUMFUNCTIONS,PDIM,WORKERS,MCresult,MCerror,MC_Chi2)
!DEC$ ENDIF



!print *, ""
!call DCUHRE(ndim,NUMFUNCTIONS,yrange(1:2),yrange(3:4),ncall/2,ncall,VegasIntegrand2_DCUHRE,0d0,1d-6,0,NW,init,MCresult,MCerror,NEVAL,IFAIL,WORK)
!print *, "cuhre ",MCresult,MCerror,NEVAL,IFAIL







!userdata = 0 
!nvec =1 
!epsrel = 1d-6
!epsabs = 0d0
!flags = 0 
!key =  9 
!spin = -1

!print *, ""

!  call cuhre(ndim, NUMFUNCTIONS, VegasIntegrand2_CUBA, userdata, nvec, epsrel, epsabs, flags, ncall/2,ncall ,key, "", spin,nregions, NEVAL, IFAIL, MCresult,MCerror, MC_Chi2)

!print *, "cuba cuhre",MCresult,MCerror,NEVAL,IFAIL





!print *, ""
!nbatch = 1000
!gridno=1
!  call vegas(ndim, NUMFUNCTIONS, VegasIntegrand2_CUBA, userdata, nvec,epsrel, epsabs, flags, 1313, ncall/2,ncall, ncall/10, ncall/10, nbatch, gridno, "", spin, NEVAL, IFAIL, MCresult,MCerror, MC_Chi2)

!print *, "cuba vegas",MCresult,MCerror,NEVAL,IFAIL





!print *, ""
!nbatch = 1000
!nnew = 1000
!nmin = 2
!flatness = 25d0
!  call suave(ndim, NUMFUNCTIONS, VegasIntegrand2_CUBA, userdata, nvec,epsrel, epsabs, flags, 1313, ncall/2,ncall, nnew, nmin, flatness, "", spin, nregions,NEVAL, IFAIL, MCresult,MCerror, MC_Chi2)

!print *, "cuba suave",MCresult,MCerror,NEVAL,IFAIL


!print *, ""
! *=========================================================
!      nDim      = 2
!      kDim      = 0
!      nBuf      = 1000          ! Buffer length <5000, default = 1000
!      nSampl    = 10000           ! Number of MC events in exploration of a cell, default = 200
!      OptDrive  = 2             ! Type of Drive =0,1,2 for TrueVol,Sigma,WtMax, default = 2
!      OptEdge   = 1             ! Include vertices in sampling or not, =0,1, default =1
! *=========================================================
!      CALL GLK_Book1(8100,'WT distribution  $', 80, 0.0d0,2d0)
! *========================================================= 
!      CALL FoamA_SetnDim(          nDim)
!      CALL FoamA_SetkDim(          kDim)
!      CALL FoamA_SetnBuf(          nBuf)
!      CALL FoamA_SetnSampl(      nSampl)
!      CALL FoamA_SetOptDrive(  OptDrive)
!      CALL FoamA_SetOptEdge(    OptEdge)
!      CALL FoamA_SetChat(0)
! *------------------------------------
!      CALL FoamA_Initialize(VegasIntegrand2_FOAM)
! *------------------------------------
!      CALL WtLimitStart(1004,1005,1000,10d0)  
           
!      DO loop = 1, ncall
!         CALL FoamA_MakeEvent(VegasIntegrand2_FOAM)    ! generate MC event
!         CALL FoamA_GetMCvector(MCvector)  ! get MC event, vector
!         CALL FoamA_GetMCwt(MCwt)          ! get MC weight
!         CALL WtLimitFill(MCwt)
!         CALL GLK_Fil1(8100,MCwt,1d0)
!      ENDDO
!      CALL FoamA_Finalize(MCresult,MCerror)
!       WRITE(*,'(a,g19.9,a,g19.9,a,f7.5)') 'MCresult= ',MCresult,' +- ',MCerror,'         RelErr= ',MCerror/MCresult   !


return
END SUBROUTINE










