import vegas
import numpy as np
import math
import time

def f_batch(x):
    # evaluate integrand at multiple points simultaneously
    norm = 1013.2118364296088
    dx2 = 0.0
    for d in range(4):
        dx2 += (np.cos(x[d]) - 0.5) ** 2
    return np.exp(-100. * dx2) * norm

integ = vegas.Integrator(4 * [[0, 1]])

start_time = time.time()
integ(f_batch, nitn=10, neval=2e5)
result = integ(f_batch, nitn=10, neval=2e5)
print('result = %s   Q = %.2f' % (result, result.Q))
print("--- %s seconds ---" % (time.time() - start_time))
