import vegas
import math
import time
import numpy as np


def TestIntegrand(x):
    Msq = 91.19*91.19
    Gamma = 2.0
    eps = 0.3
    prop1 = 1.0/(x[0]*x[0]-x[1]*x[1]-Msq+Gamma*math.sqrt(Msq)*1j)
    spike1 = pow(abs(x[0]-x[2]),eps-1.0)
    aux1   = x[4]*x[4]*pow(math.cos(2.0*math.pi*x[4]),2) + math.tanh(x[4])
    if x[5]>0.5:
        step1 = x[5]
    else:
        step1 = 0.0
    i = 1
    dummy = 0.0
    while i <= x[5]*1000:
        i += 1
        i += int(i*10*pow(math.sin(x[4]),2))
        dummy = 1.0-1.2j
        if x[2] < 0.3:
            dummy = (1.0+3.3j)*math.cos(x[0])
        dummy = pow(dummy,2.5)
        if x[5]+x[1]<0.7:
            dummy += (1.0+3.3j)*math.exp(x[0]*x[0])
        dummy = pow(dummy,2.5)
        dummy += (4.0+3.3j)*math.exp(x[0]*x[0])
        if x[2]*x[1] > 0.1:
            dummy = pow(abs(dummy),0.6)
        dummy += (9.0+6.3j)*math.sinh(x[0]*x[0])
        if i%4 == 0 :
            dummy += (6.0+1.3j)*math.tanh(x[0]*x[0])
        for k in range(100):
            k+=1
            if math.sin(abs(dummy)*2.0*math.pi) > 0.0:
                dummy += (2.0+2.3j)*math.log(x[0]*x[0]+0.1)*math.cos(2.0*math.pi*k)                
    return np.real(dummy)*i*abs(prop1)*abs(prop1)*spike1*aux1*step1*1000.0
            

start_time = time.time()

integ = vegas.Integrator([[0.0, 1.0], [0.0, 1.0], [0.0, 1.0], [0.0, 1.0], [0.0, 1.0], [0.0, 1.0]])

result = integ(TestIntegrand, nitn=10, neval=100000)

if integ.mpi_rank == 0:
    print(result.summary())
    print('result = %s    Q = %.2f' % (result, result.Q))
    print("--- %s seconds ---" % (time.time() - start_time))
